diff -uwr sourceold/crates/crates.cpp source/crates/crates.cpp
--- sourceold/crates/crates.cpp	2011-10-11 21:32:46.643554600 +0800
+++ source/crates/crates.cpp	2011-12-05 15:38:18.435078100 +0800
@@ -573,11 +597,11 @@
 						message3.Format("CRATE;BEACONDEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateSpy)) && (crate.CrateSpy > 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateSpy)) && (crate.mapConfiguration.CrateSpy > 0)) {
 					Change_Character(sender,"CnC_Nod_FlameThrower_2SF");
 					Commands->Set_Is_Visible(sender,false);
 					const char *str3 = Get_Team_Name(Team);
-					message2.Format("A %s player picked up a Spy Crate.",str3);
+					message2.Format("A %s player picked up a Spy crate.mapConfiguration.",str3);
 					delete[] str3;
 					message1.Format("ppage %d [Crate] You got the Spy Crate, base defenses will ignore you until you die, buy a new character or destroy a building.",Get_Player_ID(sender));
 					StringClass msg;
@@ -590,42 +614,42 @@
 					Vector3 pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;SPY;;0;0;%f;%f;%f;%f;%f;%f;%d",pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateStealth)) && (crate.CrateStealth	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateStealth)) && (crate.mapConfiguration.CrateStealth	> 0)) {
 					Commands->Enable_Stealth(sender,true);
-					message2.Format("%ls picked up a Stealth Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Stealth crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the stealth crate! You have been given a stealth suit.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;STEALTH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender),	pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateThief))	&& (crate.CrateThief	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateThief))	&& (crate.mapConfiguration.CrateThief	> 0)) {
 					Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
-					message2.Format("%ls picked up a Thief Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Thief crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Thief Crate, you have lost all of your credits.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00evag_dsgn0028i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;THIEF;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateAmmoRegen))	&& (crate.CrateAmmoRegen	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateAmmoRegen))	&& (crate.mapConfiguration.CrateAmmoRegen	> 0)) {
 					Commands->Send_Custom_Event(obj,sender,100100,1,1);//enable regeneration of ammo on player
-					message2.Format("%ls picked up a Ammo Regeneration Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Ammo Regeneration crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Ammo Reneration Crate, your ammo will be refilled every minute.",Get_Player_ID(sender));
 					Create_2D_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");//ammo regen sound
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;AMMOREGEN;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateHumanSilo))	&& (crate.CrateHumanSilo	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateHumanSilo))	&& (crate.mapConfiguration.CrateHumanSilo	> 0)) {
 					int team = Commands->Get_Player_Type(sender);
 					Commands->Send_Custom_Event(obj,sender,100101,1,1);//enable generating of money on player
-					message2.Format("%ls picked up a Human Silo Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Human Silo crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You got the Human Silo Crate, your entier team will be granted an additional $1 credit a second until you die or change character.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Team("m00pc$$_aqob0002i1evag_snd.wav",team);//credits acquired
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;HUMANSILO;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateUberWire))	&& (crate.CrateUberWire	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateUberWire))	&& (crate.mapConfiguration.CrateUberWire	> 0)) {
 					char ubermsg[250]; sprintf(ubermsg,"[CRATE] %s got the UberWire crate! Beware!",Get_Player_Name(sender)); Send_Message(255,255,255,ubermsg);
-					message2.Format("%ls picked up a UberWire Crate.",Get_Wide_Player_Name(sender));
-					message1.Format("ppage %d [Crate] You got the UberWire Crate.",Get_Player_ID(sender));
+					message2.Format("%ls picked up a UberWire crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You got the UberWire crate.mapConfiguration.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;UBERWIRE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					Change_Character(sender,"GDI_Engineer_2SF");
@@ -697,3 +721,17 @@
 
 ScriptRegistrant<SSGM_Prevent_Destruction_Until_Entered> SSGM_Prevent_Destruction_Until_Entered_Registrant("SSGM_Prevent_Destruction_Until_Entered","");
 ScriptRegistrant<SSGM_Crate> SSGM_Crate_Registrant("SSGM_Crate","");
+
+
+class SSGM_M00_CnC_Crate :
+	public ScriptImpClass
+{
+	void SSGM_M00_CnC_Crate::Custom(GameObject* obj, int type, int param, GameObject* sender)
+	{
+		if (type == CUSTOM_EVENT_POWERUP_GRANTED && sender && !crate.mapConfiguration.EnableNewCrates)
+		{
+			Commands->Give_Money(sender, 100, false);
+		}
+	}
+};
+ScriptRegistrant<SSGM_M00_CnC_Crate> M00_CnC_Crate_Registrant("M00_CnC_Crate","");
diff -uwr sourceold/makemix/makemix.cpp source/makemix/makemix.cpp
--- sourceold/makemix/makemix.cpp	2011-10-14 21:00:12.913085900 +0800
+++ source/makemix/makemix.cpp	2011-11-26 13:48:43.054687500 +0800
@@ -83,7 +83,7 @@
 	{
 		printf("makemix tool to generate a renegade mix file from a folder full of files");
 		printf("usage:\n");
-		printf("makemix filename folder\n");
+		printf("makemix folder filename\n");
 		printf("filename is the name of the mix file to create\n");
 		printf("folder is the path to the folder containing the files to add\n");
 		printf("The mix file will be created in the folder containing makemix.exe\n");
@@ -93,15 +93,31 @@
 	char path[MAX_PATH];
 	GetCurrentDirectory(MAX_PATH, path);
 	SetCurrentDirectory(argv[1]);
-	ParseFolder(argv[1],0);
+	StringClass bp;
+	if (argv[1][1] != ':')
+	{
+		bp.Format("%s\\%s",path,argv[1]);
+	}
+	else
+	{
+		bp = argv[1];
+	}
+	ParseFolder(bp,0);
 	qsort(&Filenames[0],Filenames.Count(),sizeof(FileStruct),File_Info_Compare);
 	StringClass mp;
+	if (argv[2][1] != ':')
+	{
 	mp.Format("%s\\%s",path,argv[2]);
+	}
+	else
+	{
+		mp = argv[2];
+	}
 	MixFileCreator mix(mp);
 	for (int i = 0;i < Filenames.Count();i++)
 	{
 		StringClass str;
-		str.Format("%s\\%s",argv[1],Filenames[i].filename);
+		str.Format("%s\\%s",bp,Filenames[i].filename);
 		mix.Add_File(str,Filenames[i].filename);
 	}
 	return 0;
diff -uwr sourceold/scripts/FileFactoryListClass.cpp source/scripts/FileFactoryListClass.cpp
--- sourceold/scripts/FileFactoryListClass.cpp	2011-10-11 23:04:17.790039000 +0800
+++ source/scripts/FileFactoryListClass.cpp	2011-11-23 11:19:35.956054600 +0800
@@ -80,7 +80,7 @@
 #pragma warning(disable: 4073) //warning C4073: initializers put in library initialization area - That's EXACTLY why I put that pragma in...
 #pragma init_seg(lib) // Move this files static initializers up a level
 #pragma warning(default: 4073)
-REF_DEF2(FileFactoryListClass::Instance, FileFactoryListClass *, 0x0085DB70, 0x0085CD58);
+REF_DEF3(FileFactoryListClass::Instance, FileFactoryListClass *, 0x0085DB70, 0x0085CD58, 0x0085CE48);
 #else
 FileFactoryListClass *FileFactoryListClass::Instance = 0;
 #endif
diff -uwr sourceold/scripts/FileFactoryListClass.h source/scripts/FileFactoryListClass.h
--- sourceold/scripts/FileFactoryListClass.h	2011-10-11 21:53:04.629882800 +0800
+++ source/scripts/FileFactoryListClass.h	2011-11-23 11:19:35.885742100 +0800
@@ -18,7 +18,7 @@
 class FileFactoryListClass : public FileFactoryClass
 {
 #if !defined(WWCONFIG) && !defined(PACKAGEEDITOR)
-	static REF_DECL2(Instance, FileFactoryListClass *);
+	static REF_DECL3(Instance, FileFactoryListClass *);
 #else
 	static FileFactoryListClass *Instance;
 #endif
diff -uwr sourceold/scripts/MixFileFactoryClass.cpp source/scripts/MixFileFactoryClass.cpp
--- sourceold/scripts/MixFileFactoryClass.cpp	2011-10-11 23:05:44.881835900 +0800
+++ source/scripts/MixFileFactoryClass.cpp	2011-11-23 11:13:31.482421800 +0800
@@ -16,7 +16,6 @@
 #include "Crc32.h"
 #include <algorithm>
 
-#ifndef TTLE_EXPORTS
 MixFileFactoryClass::MixFileFactoryClass
    (const char* filePath, FileFactoryClass *parentFileFactory) : FileFactoryClass(), Factory(0), UnkOffset(0), FileCount(0), MixFilenameOffset(0), IsValid(false), FileAdded(false)
 {
@@ -137,7 +136,6 @@
 		Factory->Return_File(f);
 	}
 }
-#endif
 SimpleFileFactoryClass SimpleFileFactory;
 
 MixFileCreator::MixFileCreator(const char *name)
Only in source/scripts: ScriptManager.h
diff -uwr sourceold/scripts/Vector3.h source/scripts/Vector3.h
--- sourceold/scripts/Vector3.h	2011-10-11 21:41:06.523437500 +0800
+++ source/scripts/Vector3.h	2011-11-22 14:49:49.197265600 +0800
@@ -72,15 +72,12 @@
 	}
 	TT_INLINE void Normalize()
 	{
-		float len2 = Length2();
-		if (len2 != 0.0f)
-		{
+		float len2 = WWMATH_FLOAT_TINY + Length2();
 			float oolen = WWMath::Inv_Sqrt(len2);
 			X *= oolen;
 			Y *= oolen;
 			Z *= oolen;
 		}
-	}
 	TT_INLINE float Length() const
 	{
 		return WWMath::Sqrt(Length2());
@@ -386,13 +383,8 @@
 }
 TT_INLINE Vector3 Normalize(const Vector3 &vec)
 {
-	float len2 = vec.Length2();
-	if (len2 != 0.0f)
-	{
-		float oolen = WWMath::Inv_Sqrt(len2);
-		return vec * oolen;
-	}
-	return vec;
+	float len2 = WWMATH_FLOAT_TINY + vec.Length2();
+	return vec * WWMath::Inv_Sqrt(len2);
 }
 TT_INLINE void Swap(Vector3 &a,Vector3 &b)
 {
diff -uwr sourceold/scripts/WeaponClass.h source/scripts/WeaponClass.h
--- sourceold/scripts/WeaponClass.h	2011-10-11 21:40:34.213867100 +0800
+++ source/scripts/WeaponClass.h	2011-11-22 14:49:49.184570300 +0800
@@ -101,8 +101,8 @@
 	float				Get_Recoil_Scale( void )	{ return Definition->RecoilScale; }
 	void				Set_Total_Rounds( int num );
 	int				Get_Total_Rounds( void );
-	void Import_Ammo_Info(int ammoInfo);
-	int Export_Ammo_Info();
+	void Import_Ammo_Info(int16 ammoInfo);
+	int16 Export_Ammo_Info();
 	void				Add_Rounds( int num );
 	void				Add_Rounds_Client( int num );
 	void				Set_Clip_Rounds( int rounds );
diff -uwr sourceold/scripts/anticheat.ini source/scripts/anticheat.ini
--- sourceold/scripts/anticheat.ini	2011-10-09 21:43:06.337890600 +0800
+++ source/scripts/anticheat.ini	2011-12-05 15:24:43.332539100 +0800
@@ -48,3 +48,6 @@
 0f43be4f2fecf73539d5b72217d05804=M08.mix
 d36d8b57f2919c12688355179542ed96=hud_sniper.dds
 352af7c3b9673ae59ba5ff430a6c036c=stealth_effect.dds
+cbc396725a03305b6b6f5ce7ea699b17=always3.dat
+fc9931e6588e44d620ba233caf4004c8=mnatr_mct.w3d
+5bc57e1d26b07fd553a703c18616f405=mnatr_mct.w3d
Only in sourceold/scripts: d3dx9.h
diff -uwr sourceold/scripts/dp88_ar.cpp source/scripts/dp88_ar.cpp
--- sourceold/scripts/dp88_ar.cpp	2011-10-25 07:50:47.750976500 +0800
+++ source/scripts/dp88_ar.cpp	2011-12-01 12:13:35.659179600 +0800
@@ -1805,14 +1805,40 @@
 	if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+		animstate = 0;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 	}
 	else
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	{
+		animstate = 1;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	}
 
 	Commands->Enable_HUD_Pokable_Indicator(obj, (m_nChargeTime == 0));
 }
 
+void dp88_RemoteControlConsole::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	switch(animstate)
+	{
+	case 0:
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+		break;
+	case 1:
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+		break;
+	case 2:
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
+		break;
+	case 3:
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+		break;
+	case 4:
+		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), false, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
+		break;
+	}
+}
+
 void dp88_RemoteControlConsole::Poked ( GameObject *obj, GameObject *poker )
 {
 	//Console_Output ( "[%d:%s:%s] Poked\n", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), this->Get_Name() );
@@ -1957,10 +1983,14 @@
 			if ( m_nChargeTime > 0 )
 			{
 				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+				animstate = 0;
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 			}
 			else
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+			{
+				animstate = 1;
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+			}
 		}
 
 		Commands->Enable_HUD_Pokable_Indicator(obj, (m_bEnabled && m_nChargeTime == 0));
@@ -2015,7 +2045,8 @@
 			Create_2D_Sound_Player(pilot, Get_Parameter("connectionEstablishedSound") );
 
 			// Set animation frame
-			Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
+			animstate = 2;
+			Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameActive1"), (float)Get_Int_Parameter("animFrameActive2"), false );
 		}
 		else	// This should never actually happen... but just in case...
 		{
@@ -2047,7 +2078,8 @@
 				Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
 			else
 			{
-				Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+				animstate = 1;
+				Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
 				Commands->Enable_HUD_Pokable_Indicator(obj, true);
 			}
 		}
@@ -2078,14 +2110,21 @@
 
 	// Update the animation frame state
 	if ( !m_bEnabled )
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	{
+		animstate = 3;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	}
 	else if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+		animstate = 0;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 	}
 	else
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	{
+		animstate = 1;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	}
 }
 
 void dp88_RemoteControlConsole::CreateDummy ( GameObject* pilot, Vector3 position, float facing )
@@ -2149,16 +2188,26 @@
 
 	// Set animation frame
 	if ( !m_bEnabled )
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	{
+		animstate = 3;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameDisabled1"), (float)Get_Int_Parameter("animFrameDisabled2"), false );
+	}
 	else if ( vehicle )
-		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), true, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
+	{
+		animstate = 4;
+		Commands->Set_Animation(obj, Get_Parameter("animFrameIdle1"), false, NULL, (float)Get_Int_Parameter("animFrameIdle2"), (float)Get_Int_Parameter("animFrameActive2"), false );
+	}
 	else if ( m_nChargeTime > 0 )
 	{
 		Commands->Start_Timer( obj, this, 1.0f, TIMER_REMOTECONTROL_CHARGETICK);
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
+		animstate = 0;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameCharging1"), (float)Get_Int_Parameter("animFrameCharging2"), false );
 	}
 	else
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), true, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	{
+		animstate = 1;
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)Get_Int_Parameter("animFrameAvailable1"), (float)Get_Int_Parameter("animFrameAvailable2"), false );
+	}
 }
 
 
diff -uwr sourceold/scripts/dp88_ar.h source/scripts/dp88_ar.h
--- sourceold/scripts/dp88_ar.h	2011-10-25 07:50:47.747070300 +0800
+++ source/scripts/dp88_ar.h	2011-12-01 12:10:36.260742100 +0800
@@ -389,6 +389,7 @@
 	void Custom( GameObject *obj, int type, int param, GameObject *sender );
 	void Timer_Expired( GameObject *obj, int number );
 	void SetEnabled ( GameObject* obj, bool state );
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	int vehicleID;
 	int pilotID;
@@ -396,6 +397,7 @@
 	Vector3 pilotDummyPos;
 	bool m_bEnabled;
 	int m_nChargeTime;
+	int animstate;
 
 	void CreateDummy ( GameObject* pilot, Vector3 position, float facing );
 	void DestroyDummy();
diff -uwr sourceold/scripts/dp88_buildingScripts.cpp source/scripts/dp88_buildingScripts.cpp
--- sourceold/scripts/dp88_buildingScripts.cpp	2011-10-25 15:38:28.234375000 +0800
+++ source/scripts/dp88_buildingScripts.cpp	2011-12-01 12:48:42.641601500 +0800
@@ -547,6 +547,18 @@
 Base Class For Generic Weakpoints
 --------------------------*/
 
+void MinorWeakpointScriptClass::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	if (animstate == 0 && Get_Int_Parameter("animLoop"))
+	{
+		Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
+	}
+	if (animstate == 1 && Get_Int_Parameter("destroyedAnimLoop"))
+	{
+		Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), false, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
+	}
+}
+
 void MinorWeakpointScriptClass::Created ( GameObject *obj )
 {
 	// Set variables
@@ -564,8 +576,8 @@
 		// Set animation
 		if ( strlen(Get_Parameter("animName")) > 0 )
 		{
-			bool loop = ( Get_Int_Parameter("animLoop") > 0 ) ? true : false;
-			Commands->Set_Animation ( obj, Get_Parameter("animName"), loop, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
+			animstate = 0;
+			Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
 		}
 	}
 	else
@@ -594,8 +606,8 @@
 		// Set animation
 		if ( strlen(Get_Parameter("destroyedAnimName")) > 0 )
 		{
-			bool loop = ( Get_Int_Parameter("destroyedAnimLoop") > 0 ) ? true : false;
-			Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), loop, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
+			animstate = 1;
+			Commands->Set_Animation ( obj, Get_Parameter("destroyedAnimName"), false, NULL, (float)Get_Int_Parameter("destroyedAnimStartFrame"), (float)Get_Int_Parameter("destroyedAnimEndFrame"), false );
 		}
 	}
 
@@ -616,8 +628,8 @@
 		// Set animation
 		if ( strlen(Get_Parameter("animName")) > 0 )
 		{
-			bool loop = ( Get_Int_Parameter("animLoop") > 0 ) ? true : false;
-			Commands->Set_Animation ( obj, Get_Parameter("animName"), loop, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
+			animstate = 0;
+			Commands->Set_Animation ( obj, Get_Parameter("animName"), false, NULL, (float)Get_Int_Parameter("animStartFrame"), (float)Get_Int_Parameter("animEndFrame"), false );
 		}
 	}
 }
diff -uwr sourceold/scripts/dp88_buildingScripts.h source/scripts/dp88_buildingScripts.h
--- sourceold/scripts/dp88_buildingScripts.h	2011-10-22 18:09:56.484375000 +0800
+++ source/scripts/dp88_buildingScripts.h	2011-12-01 12:29:48.027343700 +0800
@@ -117,6 +117,7 @@
 	void Damaged ( GameObject *obj, GameObject *damager, float amount );
 	void Killed( GameObject *obj, GameObject *killer );
 	void Custom( GameObject *obj, int type, int param, GameObject *sender );
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	// ID of the building controller we belong to
 	int parentId;
@@ -124,6 +125,7 @@
 	// We use this to remember when we are in the destroyed state, so we know
 	// that when we next reach 100% health we need to trigger the repaired event
 	bool isDestroyed;
+	int animstate;
 
 	// Abstract functions
 	virtual void applyEffect ( GameObject *obj, GameObject *parent ) = 0;
diff -uwr sourceold/scripts/dp88_misc.cpp source/scripts/dp88_misc.cpp
--- sourceold/scripts/dp88_misc.cpp	2011-10-11 23:03:39.628906200 +0800
+++ source/scripts/dp88_misc.cpp	2011-12-01 11:52:12.948242100 +0800
@@ -642,6 +642,14 @@
 	}
 }
 
+void dp88_damageAnimation::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	if (loopAnimation)
+	{
+		SetDamageAnimation(obj);
+	}
+}
+
 void dp88_damageAnimation::Damaged( GameObject *obj, GameObject *damager, float amount )
 {
 	if ( amount >= 0 )
@@ -686,9 +694,9 @@
 void dp88_damageAnimation::SetDamageAnimation ( GameObject* obj )
 {
 	if ( basePowerState || damageLevelLowPowerStartFrames[currentDamageLevel] < 0 )
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), loopAnimation, NULL, (float)damageLevelStartFrames[currentDamageLevel], (float)damageLevelEndFrames[currentDamageLevel], false );
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)damageLevelStartFrames[currentDamageLevel], (float)damageLevelEndFrames[currentDamageLevel], false );
 	else
-		Commands->Set_Animation(obj, Get_Parameter("animationName"), loopAnimation, NULL, (float)damageLevelLowPowerStartFrames[currentDamageLevel], (float)damageLevelLowPowerEndFrames[currentDamageLevel], false );
+		Commands->Set_Animation(obj, Get_Parameter("animationName"), false, NULL, (float)damageLevelLowPowerStartFrames[currentDamageLevel], (float)damageLevelLowPowerEndFrames[currentDamageLevel], false );
 }
 
 
diff -uwr sourceold/scripts/dp88_misc.h source/scripts/dp88_misc.h
--- sourceold/scripts/dp88_misc.h	2011-10-14 22:27:32.112304600 +0800
+++ source/scripts/dp88_misc.h	2011-12-01 11:52:12.871093700 +0800
@@ -113,6 +113,7 @@
 	void Created ( GameObject* obj );
 	void Damaged( GameObject *obj, GameObject *damager, float amount );
 	void Timer_Expired ( GameObject* obj, int number );
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	void SetDamageAnimation ( GameObject* obj );
 
diff -uwr sourceold/scripts/engine_3dre.h source/scripts/engine_3dre.h
--- sourceold/scripts/engine_3dre.h	2011-10-11 21:54:26.711914000 +0800
+++ source/scripts/engine_3dre.h	2011-11-07 15:17:05.800781200 +0800
@@ -36,6 +36,8 @@
 class FontCharsClass;
 class RenderInfoClass;
 
+#define FOURCC_INTZ ((D3DFORMAT)(MAKEFOURCC('I','N','T','Z')))
+
 enum WW3DFormat {
 	WW3D_FORMAT_UNKNOWN = 0x0,
 	WW3D_FORMAT_R8G8B8 = 0x1,
@@ -76,6 +78,8 @@
 	WW3D_FORMAT_R32F,
 	WW3D_FORMAT_GR32F,
 	WW3D_FORMAT_ABGR32F,
+	// Vendor hack formats
+	WW3D_FORMAT_INTZ,
 
 	WW3D_FORMAT_COUNT,
 };
@@ -94,6 +98,7 @@
 	case WW3D_FORMAT_X8L8V8U8:
 	case WW3D_FORMAT_R32F:	
 	case WW3D_FORMAT_GR16F:
+	case WW3D_FORMAT_INTZ:
 		return 4;
 	case WW3D_FORMAT_R8G8B8:
 		return 3;
@@ -141,6 +146,7 @@
 	static bool SupportDXTC; // is DXTC supported
 	static bool SupportTextureFormat[WW3D_FORMAT_COUNT]; // texture format support
 	static bool SupportGamma;
+	static bool SupportINTZ; // is native depth buffer access supported
 };
 
 enum ShaderShiftConstants
@@ -507,7 +513,7 @@
 	TextureMapperClass(TextureMapperClass& src);
 	TextureMapperClass(unsigned int stage=0);
 	TextureMapperClass(INIClass& ini,char* section,unsigned int stage);
-	SHADERS_API void Set_Shader(const char* shader_name, ProgrammableShader* shader);
+	SHADERS_API void Set_Shader(const char* shader_name, ProgrammableShader* shader = nullptr);
 	ProgrammableShader *Peek_Shader()
 	{
 		return Shader;
diff -uwr sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2011-10-20 22:43:20.420898400 +0800
+++ source/scripts/engine_tt.cpp	2011-11-07 20:07:04.130859300 +0800
@@ -27,6 +27,7 @@
 #include "VehicleFactoryGameObj.h"
 #include "VehicleFactoryGameObjDef.h"
 #include "AirFactoryGameObj.h"
+#include "Iterator.h"
 class WideStringClass;
 
 
@@ -816,6 +817,22 @@
 
 SCRIPTS_API REF_DEF2(ConsoleFunctionList,DynamicVectorClass<ConsoleFunctionClass *>,0x0081DEB8,0x0081D098);
 
+SCRIPTS_API void Delete_Console_Function(const char *name)
+{
+	const DynamicVectorClass<ConsoleFunctionClass*> consoleFunctions(ConsoleFunctionList);
+	TT_FOREACH(consoleFunction, consoleFunctions)
+	{
+		const char* fname = (*consoleFunction)->Get_Name();
+		if (fname)
+		{
+			if (strcmp(fname,name) == 0)
+			{
+				ConsoleFunctionList.Delete(consoleFunction);
+			}
+		}
+	}
+}
+
 RENEGADE_FUNCTION
 SCRIPTS_API void Sort_Function_List()
 AT2(0x004282F0,0x00428470);
diff -uwr sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2011-10-11 21:53:26.168945300 +0800
+++ source/scripts/engine_tt.h	2011-11-07 20:07:04.007812500 +0800
@@ -347,5 +347,6 @@
 SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, Vector3 value, GameObject* object);
 SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, Vector4 value, GameObject* object);
 SCRIPTS_API extern REF_DECL2(ConsoleFunctionList,DynamicVectorClass<ConsoleFunctionClass *>);
+SCRIPTS_API void Delete_Console_Function(const char *name);
 SCRIPTS_API void Sort_Function_List();
 SCRIPTS_API void Verbose_Help_File();
diff -uwr sourceold/scripts/engine_vector.h source/scripts/engine_vector.h
--- sourceold/scripts/engine_vector.h	2011-10-12 09:16:51.028320300 +0800
+++ source/scripts/engine_vector.h	2011-11-28 09:12:59.829890600 +0800
@@ -686,6 +686,15 @@
 		}
 		return true;
 	}
+
+	void Uninitialized_Resize(int newsize)
+	{
+		assert(newsize > 0);
+		delete[] Vector;
+		Vector = new T[newsize];
+		VectorMax = newsize;
+	}
+
 	int Length() const
 	{
 		return VectorMax;
diff -uwr sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2011-10-14 21:29:00.915039000 +0800
+++ source/scripts/gmgame.cpp	2011-11-07 20:41:54.807617100 +0800
@@ -28,6 +28,7 @@
 #include "gmlog.h"
 #include "GameObjManager.h"
 #include "C4GameObj.h"
+#include "ScriptManager.h"
 
 SimpleDynVecClass<Plugin *> RegisteredEvents[EVENT_COUNT];
 SimpleDynVecClass<Plugin *> Plugins;
@@ -402,6 +403,7 @@
 			{
 				deleteobservers[i]->Destroy_Script();
 			}
+			ScriptManager::Destroy_Pending();
 		}
 		Attach_Script_Once(obj,"SSGM_Soldier","");
 	}
Only in source/scripts: iran_scripts.cpp
Only in source/scripts: iran_scripts.h
